javax.ws.rs.core

## Class Application

- java.lang.Object
- - javax.ws.rs.core.Application

-     public class Application
      extends Object

  Defines the components of a JAX-RS application and supplies additional meta-data. A JAX-RS application or implementation supplies a concrete subclass of this abstract class.

  The implementation-created instance of an Application subclass may be injected into resource classes and providers using `Context`.

  In case any of the `Application` subclass methods or it's constructor throws a `RuntimeException`, the deployment of the application SHOULD be aborted with a failure.

  Since:
    1.0
  Author:
    Paul Sandoz, Marc Hadley, Marek Potociar

- - ### Constructor Summary

    Constructors
    Constructor and Description
    `Application()`

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `Set<Class<?>>` | `getClasses()` Get a set of root resource, provider and `feature` classes.
    `Map<String,Object>` | `getProperties()` Get a map of custom application-wide properties.
    `Set<Object>` | `getSingletons()` Get a set of root resource, provider and `feature` instances.

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### Application

          public Application()

  - ### Method Detail

    - #### getClasses

          public Set<Class<?>> getClasses()

      Get a set of root resource, provider and `feature` classes. The default life-cycle for resource class instances is per-request. The default life-cycle for providers (registered directly or via a feature) is singleton.

      Implementations should warn about and ignore classes that do not conform to the requirements of root resource or provider/feature classes. Implementations should warn about and ignore classes for which `getSingletons()` returns an instance. Implementations MUST NOT modify the returned set.

      The default implementation returns an empty set.

      Returns:
        a set of root resource and provider classes. Returning `null` is equivalent to returning an empty set.

    - #### getSingletons

          public Set<Object> getSingletons()

      Get a set of root resource, provider and `feature` instances. Fields and properties of returned instances are injected with their declared dependencies (see `Context`) by the runtime prior to use.

      Implementations should warn about and ignore classes that do not conform to the requirements of root resource or provider classes. Implementations should flag an error if the returned set includes more than one instance of the same class. Implementations MUST NOT modify the returned set.

      The default implementation returns an empty set.

      Returns:
        a set of root resource and provider instances. Returning `null` is equivalent to returning an empty set.

    - #### getProperties

          public Map<String,Object> getProperties()

      Get a map of custom application-wide properties.

      The returned properties are reflected in the application `configuration` passed to the server-side features or injected into server-side JAX-RS components.

      The set of returned properties may be further extended or customized at deployment time using container-specific features and deployment descriptors. For example, in a Servlet-based deployment scenario, web application's `<context-param>` and Servlet `<init-param>` values may be used to extend or override values of the properties programmatically returned by this method.

      The default implementation returns an empty set.

      Returns:
        a map of custom application-wide properties. Returning `null` is equivalent to returning an empty set.
      Since:
        2.0

Copyright © 1996-2013, Oracle and/or its affiliates. All Rights Reserved. Use is subject to license terms.